// chrome/common/available_offline_content.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_AVAILABLE_OFFLINE_CONTENT_MOJOM_SHARED_H_
#define CHROME_COMMON_AVAILABLE_OFFLINE_CONTENT_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "chrome/common/available_offline_content.mojom-shared-internal.h"
#include "url/mojom/url.mojom-shared.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"






namespace chrome::mojom {
class AvailableOfflineContentDataView;



}  // chrome::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::chrome::mojom::AvailableOfflineContentDataView> {
  using Data = ::chrome::mojom::internal::AvailableOfflineContent_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace chrome::mojom {


enum class AvailableContentType : int32_t {
  
  kPrefetchedPage = 0,
  
  kVideo = 1,
  
  kAudio = 2,
  
  kOtherPage = 3,
  
  kUninteresting = 4,
  kMinValue = 0,
  kMaxValue = 4,
};

 std::ostream& operator<<(std::ostream& os, AvailableContentType value);
inline bool IsKnownEnumValue(AvailableContentType value) {
  return internal::AvailableContentType_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class AvailableOfflineContentProviderInterfaceBase {};

using AvailableOfflineContentProviderPtrDataView =
    mojo::InterfacePtrDataView<AvailableOfflineContentProviderInterfaceBase>;
using AvailableOfflineContentProviderRequestDataView =
    mojo::InterfaceRequestDataView<AvailableOfflineContentProviderInterfaceBase>;
using AvailableOfflineContentProviderAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<AvailableOfflineContentProviderInterfaceBase>;
using AvailableOfflineContentProviderAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<AvailableOfflineContentProviderInterfaceBase>;


class AvailableOfflineContentDataView {
 public:
  AvailableOfflineContentDataView() = default;

  AvailableOfflineContentDataView(
      internal::AvailableOfflineContent_Data* data,
      mojo::Message* message)
      : data_(data), message_(message) {}

  bool is_null() const { return !data_; }
  inline void GetIdDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadId(UserType* output) {
    
    auto* pointer = data_->id.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetNameSpaceDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadNameSpace(UserType* output) {
    
    auto* pointer = data_->name_space.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetTitleDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadTitle(UserType* output) {
    
    auto* pointer = data_->title.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetSnippetDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadSnippet(UserType* output) {
    
    auto* pointer = data_->snippet.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetDateModifiedDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadDateModified(UserType* output) {
    
    auto* pointer = data_->date_modified.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetAttributionDataView(
      mojo::StringDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadAttribution(UserType* output) {
    
    auto* pointer = data_->attribution.Get();
    return mojo::internal::Deserialize<mojo::StringDataView>(
        pointer, output, message_);
  }
  inline void GetThumbnailDataUriDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadThumbnailDataUri(UserType* output) {
    
    auto* pointer = data_->thumbnail_data_uri.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, message_);
  }
  inline void GetFaviconDataUriDataView(
      ::url::mojom::UrlDataView* output);

  template <typename UserType>
  [[nodiscard]] bool ReadFaviconDataUri(UserType* output) {
    
    auto* pointer = data_->favicon_data_uri.Get();
    return mojo::internal::Deserialize<::url::mojom::UrlDataView>(
        pointer, output, message_);
  }
  template <typename UserType>
  [[nodiscard]] bool ReadContentType(UserType* output) const {
    auto data_value = data_->content_type;
    return mojo::internal::Deserialize<::chrome::mojom::AvailableContentType>(
        data_value, output);
  }
  AvailableContentType content_type() const {
    return ::mojo::internal::ToKnownEnumValueHelper(
          static_cast<::chrome::mojom::AvailableContentType>(data_->content_type));
  }
 private:
  internal::AvailableOfflineContent_Data* data_ = nullptr;
  mojo::Message* message_ = nullptr;
};


}  // chrome::mojom

namespace std {

template <>
struct hash<::chrome::mojom::AvailableContentType>
    : public mojo::internal::EnumHashImpl<::chrome::mojom::AvailableContentType> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::chrome::mojom::AvailableContentType, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::chrome::mojom::AvailableContentType, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::chrome::mojom::AvailableContentType>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::chrome::mojom::AvailableOfflineContentDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::chrome::mojom::AvailableOfflineContentDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::chrome::mojom::internal::AvailableOfflineContent_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    decltype(Traits::id(input)) in_id = Traits::id(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->id)::BaseType> id_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_id, id_fragment);
    fragment->id.Set(
        id_fragment.is_null() ? nullptr : id_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->id.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null id in AvailableOfflineContent struct");
    decltype(Traits::name_space(input)) in_name_space = Traits::name_space(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->name_space)::BaseType> name_space_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_name_space, name_space_fragment);
    fragment->name_space.Set(
        name_space_fragment.is_null() ? nullptr : name_space_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->name_space.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null name_space in AvailableOfflineContent struct");
    decltype(Traits::title(input)) in_title = Traits::title(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->title)::BaseType> title_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_title, title_fragment);
    fragment->title.Set(
        title_fragment.is_null() ? nullptr : title_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->title.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null title in AvailableOfflineContent struct");
    decltype(Traits::snippet(input)) in_snippet = Traits::snippet(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->snippet)::BaseType> snippet_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_snippet, snippet_fragment);
    fragment->snippet.Set(
        snippet_fragment.is_null() ? nullptr : snippet_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->snippet.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null snippet in AvailableOfflineContent struct");
    decltype(Traits::date_modified(input)) in_date_modified = Traits::date_modified(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->date_modified)::BaseType> date_modified_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_date_modified, date_modified_fragment);
    fragment->date_modified.Set(
        date_modified_fragment.is_null() ? nullptr : date_modified_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->date_modified.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null date_modified in AvailableOfflineContent struct");
    decltype(Traits::attribution(input)) in_attribution = Traits::attribution(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->attribution)::BaseType> attribution_fragment(
            fragment.message());
    mojo::internal::Serialize<mojo::StringDataView>(
        in_attribution, attribution_fragment);
    fragment->attribution.Set(
        attribution_fragment.is_null() ? nullptr : attribution_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->attribution.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null attribution in AvailableOfflineContent struct");
    decltype(Traits::thumbnail_data_uri(input)) in_thumbnail_data_uri = Traits::thumbnail_data_uri(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->thumbnail_data_uri)::BaseType> thumbnail_data_uri_fragment(
            fragment.message());
    mojo::internal::Serialize<::url::mojom::UrlDataView>(
        in_thumbnail_data_uri, thumbnail_data_uri_fragment);
    fragment->thumbnail_data_uri.Set(
        thumbnail_data_uri_fragment.is_null() ? nullptr : thumbnail_data_uri_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->thumbnail_data_uri.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null thumbnail_data_uri in AvailableOfflineContent struct");
    decltype(Traits::favicon_data_uri(input)) in_favicon_data_uri = Traits::favicon_data_uri(input);
    mojo::internal::MessageFragment<
        typename decltype(fragment->favicon_data_uri)::BaseType> favicon_data_uri_fragment(
            fragment.message());
    mojo::internal::Serialize<::url::mojom::UrlDataView>(
        in_favicon_data_uri, favicon_data_uri_fragment);
    fragment->favicon_data_uri.Set(
        favicon_data_uri_fragment.is_null() ? nullptr : favicon_data_uri_fragment.data());
    MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
        fragment->favicon_data_uri.is_null(),
        mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
        "null favicon_data_uri in AvailableOfflineContent struct");
    mojo::internal::Serialize<::chrome::mojom::AvailableContentType>(
        Traits::content_type(input), &fragment->content_type);
  }

  static bool Deserialize(::chrome::mojom::internal::AvailableOfflineContent_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::chrome::mojom::AvailableOfflineContentDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace chrome::mojom {

inline void AvailableOfflineContentDataView::GetIdDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->id.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void AvailableOfflineContentDataView::GetNameSpaceDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->name_space.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void AvailableOfflineContentDataView::GetTitleDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->title.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void AvailableOfflineContentDataView::GetSnippetDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->snippet.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void AvailableOfflineContentDataView::GetDateModifiedDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->date_modified.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void AvailableOfflineContentDataView::GetAttributionDataView(
    mojo::StringDataView* output) {
  auto pointer = data_->attribution.Get();
  *output = mojo::StringDataView(pointer, message_);
}
inline void AvailableOfflineContentDataView::GetThumbnailDataUriDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->thumbnail_data_uri.Get();
  *output = ::url::mojom::UrlDataView(pointer, message_);
}
inline void AvailableOfflineContentDataView::GetFaviconDataUriDataView(
    ::url::mojom::UrlDataView* output) {
  auto pointer = data_->favicon_data_uri.Get();
  *output = ::url::mojom::UrlDataView(pointer, message_);
}



}  // chrome::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct  TraceFormatTraits<::chrome::mojom::AvailableContentType> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::chrome::mojom::AvailableContentType value);
};

} // namespace perfetto

#endif  // CHROME_COMMON_AVAILABLE_OFFLINE_CONTENT_MOJOM_SHARED_H_