// chrome/common/metrics.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef CHROME_COMMON_METRICS_MOJOM_H_
#define CHROME_COMMON_METRICS_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "chrome/common/metrics.mojom-features.h"
#include "chrome/common/metrics.mojom-shared.h"
#include "chrome/common/metrics.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"






namespace chrome::mojom {

class MetricsServiceProxy;

template <typename ImplRefTraits>
class MetricsServiceStub;

class MetricsServiceRequestValidator;
class MetricsServiceResponseValidator;


class MetricsService
    : public MetricsServiceInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static inline constexpr uint32_t kSyncMethodOrdinals[] = {
    606022646
  };
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = MetricsServiceInterfaceBase;
  using Proxy_ = MetricsServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = MetricsServiceStub<ImplRefTraits>;

  using RequestValidator_ = MetricsServiceRequestValidator;
  using ResponseValidator_ = MetricsServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kIsMetricsAndCrashReportingEnabledMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct IsMetricsAndCrashReportingEnabled_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~MetricsService() = default;

  // Sync method. This signature is used by the client side; the service side
  // should implement the signature with callback below.
  
  virtual bool IsMetricsAndCrashReportingEnabled(bool* out_result);

  using IsMetricsAndCrashReportingEnabledCallback = base::OnceCallback<void(bool)>;
  
  virtual void IsMetricsAndCrashReportingEnabled(IsMetricsAndCrashReportingEnabledCallback callback) = 0;
};



class  MetricsServiceProxy
    : public MetricsService {
 public:
  using InterfaceType = MetricsService;

  explicit MetricsServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  bool IsMetricsAndCrashReportingEnabled(bool* out_result) final;
  
  void IsMetricsAndCrashReportingEnabled(IsMetricsAndCrashReportingEnabledCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  MetricsServiceStubDispatch {
 public:
  static bool Accept(MetricsService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      MetricsService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<MetricsService>>
class MetricsServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  MetricsServiceStub() = default;
  ~MetricsServiceStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return MetricsServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return MetricsServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  MetricsServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  MetricsServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // chrome::mojom

namespace mojo {

}  // namespace mojo

#endif  // CHROME_COMMON_METRICS_MOJOM_H_