// components/services/language_detection/public/mojom/language_detection.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef COMPONENTS_SERVICES_LANGUAGE_DETECTION_PUBLIC_MOJOM_LANGUAGE_DETECTION_MOJOM_H_
#define COMPONENTS_SERVICES_LANGUAGE_DETECTION_PUBLIC_MOJOM_LANGUAGE_DETECTION_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "components/services/language_detection/public/mojom/language_detection.mojom-features.h"
#include "components/services/language_detection/public/mojom/language_detection.mojom-shared.h"
#include "components/services/language_detection/public/mojom/language_detection.mojom-forward.h"
#include "mojo/public/mojom/base/string16.mojom.h"
#include "sandbox/policy/mojom/sandbox.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"






namespace language_detection::mojom {

class LanguageDetectionServiceProxy;

template <typename ImplRefTraits>
class LanguageDetectionServiceStub;

class LanguageDetectionServiceRequestValidator;
class LanguageDetectionServiceResponseValidator;


class LanguageDetectionService
    : public LanguageDetectionServiceInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr auto kServiceSandbox = sandbox::mojom::Sandbox::kService;
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = LanguageDetectionServiceInterfaceBase;
  using Proxy_ = LanguageDetectionServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = LanguageDetectionServiceStub<ImplRefTraits>;

  using RequestValidator_ = LanguageDetectionServiceRequestValidator;
  using ResponseValidator_ = LanguageDetectionServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kDetermineLanguageMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct DetermineLanguage_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~LanguageDetectionService() = default;


  using DetermineLanguageCallback = base::OnceCallback<void(const std::string&, bool)>;
  
  virtual void DetermineLanguage(const ::std::u16string& text, DetermineLanguageCallback callback) = 0;
};



class  LanguageDetectionServiceProxy
    : public LanguageDetectionService {
 public:
  using InterfaceType = LanguageDetectionService;

  explicit LanguageDetectionServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void DetermineLanguage(const ::std::u16string& text, DetermineLanguageCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  LanguageDetectionServiceStubDispatch {
 public:
  static bool Accept(LanguageDetectionService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      LanguageDetectionService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<LanguageDetectionService>>
class LanguageDetectionServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  LanguageDetectionServiceStub() = default;
  ~LanguageDetectionServiceStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return LanguageDetectionServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return LanguageDetectionServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  LanguageDetectionServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  LanguageDetectionServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // language_detection::mojom

namespace mojo {

}  // namespace mojo

#endif  // COMPONENTS_SERVICES_LANGUAGE_DETECTION_PUBLIC_MOJOM_LANGUAGE_DETECTION_MOJOM_H_