// services/on_device_model/public/mojom/on_device_model.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "services/on_device_model/public/mojom/on_device_model.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "services/on_device_model/public/mojom/on_device_model.mojom-params-data.h"
namespace on_device_model {
namespace mojom {

NOINLINE static const char* PerformanceClassToStringHelper(PerformanceClass value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case PerformanceClass::kError:
      return "kError";
    case PerformanceClass::kGpuBlocked:
      return "kGpuBlocked";
    case PerformanceClass::kFailedToLoadLibrary:
      return "kFailedToLoadLibrary";
    case PerformanceClass::kVeryLow:
      return "kVeryLow";
    case PerformanceClass::kLow:
      return "kLow";
    case PerformanceClass::kMedium:
      return "kMedium";
    case PerformanceClass::kHigh:
      return "kHigh";
    case PerformanceClass::kVeryHigh:
      return "kVeryHigh";
    default:
      return nullptr;
  }
}

std::string PerformanceClassToString(PerformanceClass value) {
  const char *str = PerformanceClassToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown PerformanceClass value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, PerformanceClass value) {
  return os << PerformanceClassToString(value);
}

NOINLINE static const char* LoadModelResultToStringHelper(LoadModelResult value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case LoadModelResult::kSuccess:
      return "kSuccess";
    case LoadModelResult::kGpuBlocked:
      return "kGpuBlocked";
    case LoadModelResult::kFailedToLoadLibrary:
      return "kFailedToLoadLibrary";
    default:
      return nullptr;
  }
}

std::string LoadModelResultToString(LoadModelResult value) {
  const char *str = LoadModelResultToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown LoadModelResult value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, LoadModelResult value) {
  return os << LoadModelResultToString(value);
}

namespace internal {


// static
bool AdaptationAssets_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const AdaptationAssets_Data* object =
      static_cast<const AdaptationAssets_Data*>(data);

  if (!mojo::internal::ValidateStruct(object->weights, validation_context))
    return false;

  return true;
}

AdaptationAssets_Data::AdaptationAssets_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool LanguageDetectionResult_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const LanguageDetectionResult_Data* object =
      static_cast<const LanguageDetectionResult_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->code, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& code_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->code, validation_context,
                                         &code_validate_params)) {
    return false;
  }

  return true;
}

LanguageDetectionResult_Data::LanguageDetectionResult_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool SafetyInfo_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const SafetyInfo_Data* object =
      static_cast<const SafetyInfo_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->class_scores, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& class_scores_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->class_scores, validation_context,
                                         &class_scores_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidateStruct(object->language, validation_context))
    return false;

  return true;
}

SafetyInfo_Data::SafetyInfo_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool ResponseChunk_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const ResponseChunk_Data* object =
      static_cast<const ResponseChunk_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->text, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& text_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->text, validation_context,
                                         &text_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidateStruct(object->safety_info, validation_context))
    return false;

  return true;
}

ResponseChunk_Data::ResponseChunk_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool ResponseSummary_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const ResponseSummary_Data* object =
      static_cast<const ResponseSummary_Data*>(data);

  if (!mojo::internal::ValidateStruct(object->safety_info, validation_context))
    return false;

  return true;
}

ResponseSummary_Data::ResponseSummary_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool LoadAdaptationParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const LoadAdaptationParams_Data* object =
      static_cast<const LoadAdaptationParams_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->assets, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->assets, validation_context))
    return false;

  return true;
}

LoadAdaptationParams_Data::LoadAdaptationParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool InputOptions_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 48, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const InputOptions_Data* object =
      static_cast<const InputOptions_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->text, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& text_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->text, validation_context,
                                         &text_validate_params)) {
    return false;
  }

  return true;
}

InputOptions_Data::InputOptions_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool StreamingResponder_OnResponse_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const StreamingResponder_OnResponse_Params_Data* object =
      static_cast<const StreamingResponder_OnResponse_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->chunk, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->chunk, validation_context))
    return false;

  return true;
}

StreamingResponder_OnResponse_Params_Data::StreamingResponder_OnResponse_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool StreamingResponder_OnComplete_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const StreamingResponder_OnComplete_Params_Data* object =
      static_cast<const StreamingResponder_OnComplete_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->summary, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->summary, validation_context))
    return false;

  return true;
}

StreamingResponder_OnComplete_Params_Data::StreamingResponder_OnComplete_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool ContextClient_OnComplete_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const ContextClient_OnComplete_Params_Data* object =
      static_cast<const ContextClient_OnComplete_Params_Data*>(data);

  return true;
}

ContextClient_OnComplete_Params_Data::ContextClient_OnComplete_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Session_AddContext_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const Session_AddContext_Params_Data* object =
      static_cast<const Session_AddContext_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->input, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->input, validation_context))
    return false;

  if (!mojo::internal::ValidateHandleOrInterface(object->client,
                                                 validation_context)) {
    return false;
  }

  return true;
}

Session_AddContext_Params_Data::Session_AddContext_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Session_Execute_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const Session_Execute_Params_Data* object =
      static_cast<const Session_Execute_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->input, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->input, validation_context))
    return false;

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->response, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->response,
                                                 validation_context)) {
    return false;
  }

  return true;
}

Session_Execute_Params_Data::Session_Execute_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Session_GetSizeInTokens_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const Session_GetSizeInTokens_Params_Data* object =
      static_cast<const Session_GetSizeInTokens_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->text, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& text_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->text, validation_context,
                                         &text_validate_params)) {
    return false;
  }

  return true;
}

Session_GetSizeInTokens_Params_Data::Session_GetSizeInTokens_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Session_GetSizeInTokens_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const Session_GetSizeInTokens_ResponseParams_Data* object =
      static_cast<const Session_GetSizeInTokens_ResponseParams_Data*>(data);

  return true;
}

Session_GetSizeInTokens_ResponseParams_Data::Session_GetSizeInTokens_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool OnDeviceModel_StartSession_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const OnDeviceModel_StartSession_Params_Data* object =
      static_cast<const OnDeviceModel_StartSession_Params_Data*>(data);

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->session, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->session,
                                                 validation_context)) {
    return false;
  }

  return true;
}

OnDeviceModel_StartSession_Params_Data::OnDeviceModel_StartSession_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool OnDeviceModel_ClassifyTextSafety_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const OnDeviceModel_ClassifyTextSafety_Params_Data* object =
      static_cast<const OnDeviceModel_ClassifyTextSafety_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->text, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& text_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->text, validation_context,
                                         &text_validate_params)) {
    return false;
  }

  return true;
}

OnDeviceModel_ClassifyTextSafety_Params_Data::OnDeviceModel_ClassifyTextSafety_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool OnDeviceModel_ClassifyTextSafety_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const OnDeviceModel_ClassifyTextSafety_ResponseParams_Data* object =
      static_cast<const OnDeviceModel_ClassifyTextSafety_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidateStruct(object->safety_info, validation_context))
    return false;

  return true;
}

OnDeviceModel_ClassifyTextSafety_ResponseParams_Data::OnDeviceModel_ClassifyTextSafety_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool OnDeviceModel_DetectLanguage_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const OnDeviceModel_DetectLanguage_Params_Data* object =
      static_cast<const OnDeviceModel_DetectLanguage_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->text, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& text_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->text, validation_context,
                                         &text_validate_params)) {
    return false;
  }

  return true;
}

OnDeviceModel_DetectLanguage_Params_Data::OnDeviceModel_DetectLanguage_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool OnDeviceModel_DetectLanguage_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const OnDeviceModel_DetectLanguage_ResponseParams_Data* object =
      static_cast<const OnDeviceModel_DetectLanguage_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidateStruct(object->result, validation_context))
    return false;

  return true;
}

OnDeviceModel_DetectLanguage_ResponseParams_Data::OnDeviceModel_DetectLanguage_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool OnDeviceModel_LoadAdaptation_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const OnDeviceModel_LoadAdaptation_Params_Data* object =
      static_cast<const OnDeviceModel_LoadAdaptation_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->params, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->params, validation_context))
    return false;

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->model, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->model,
                                                 validation_context)) {
    return false;
  }

  return true;
}

OnDeviceModel_LoadAdaptation_Params_Data::OnDeviceModel_LoadAdaptation_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool OnDeviceModel_LoadAdaptation_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const OnDeviceModel_LoadAdaptation_ResponseParams_Data* object =
      static_cast<const OnDeviceModel_LoadAdaptation_ResponseParams_Data*>(data);


  if (!::on_device_model::mojom::internal::LoadModelResult_Data
        ::Validate(object->result, validation_context))
    return false;

  return true;
}

OnDeviceModel_LoadAdaptation_ResponseParams_Data::OnDeviceModel_LoadAdaptation_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace on_device_model

namespace perfetto {

// static
void TraceFormatTraits<::on_device_model::mojom::PerformanceClass>::WriteIntoTrace(
   perfetto::TracedValue context, ::on_device_model::mojom::PerformanceClass value) {
  return std::move(context).WriteString(::on_device_model::mojom::PerformanceClassToString(value));
}

} // namespace perfetto

namespace perfetto {

// static
void TraceFormatTraits<::on_device_model::mojom::LoadModelResult>::WriteIntoTrace(
   perfetto::TracedValue context, ::on_device_model::mojom::LoadModelResult value) {
  return std::move(context).WriteString(::on_device_model::mojom::LoadModelResultToString(value));
}

} // namespace perfetto