// services/on_device_model/public/mojom/on_device_model_service.mojom.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#if defined(__clang__)
#pragma clang diagnostic push
#pragma clang diagnostic ignored "-Wunused-private-field"
#endif

#include "services/on_device_model/public/mojom/on_device_model_service.mojom.h"

#include <math.h>
#include <stdint.h>
#include <utility>

#include "base/debug/alias.h"
#include "base/hash/md5_constexpr.h"
#include "base/run_loop.h"
#include "base/strings/string_number_conversions.h"
#include "base/task/thread_pool/thread_pool_instance.h"
#include "base/trace_event/trace_event.h"
#include "base/trace_event/typed_macros.h"
#include "mojo/public/cpp/bindings/features.h"
#include "mojo/public/cpp/bindings/lib/default_construct_tag_internal.h"
#include "mojo/public/cpp/bindings/lib/generated_code_util.h"
#include "mojo/public/cpp/bindings/lib/message_internal.h"
#include "mojo/public/cpp/bindings/lib/proxy_to_responder.h"
#include "mojo/public/cpp/bindings/lib/send_message_helper.h"
#include "mojo/public/cpp/bindings/lib/serialization_util.h"
#include "mojo/public/cpp/bindings/lib/unserialized_message_context.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/mojo_buildflags.h"
#include "mojo/public/cpp/bindings/urgent_message_scope.h"
#include "mojo/public/interfaces/bindings/interface_control_messages.mojom.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "services/on_device_model/public/mojom/on_device_model_service.mojom-params-data.h"
#include "services/on_device_model/public/mojom/on_device_model_service.mojom-shared-message-ids.h"

#include "services/on_device_model/public/mojom/on_device_model_service.mojom-import-headers.h"
#include "services/on_device_model/public/mojom/on_device_model_service.mojom-test-utils.h"


namespace on_device_model::mojom {
ModelAssets::ModelAssets()
    : weights(),
      ts_data(),
      ts_sp_model(),
      language_detection_model() {}

ModelAssets::ModelAssets(
    ::base::File weights_in,
    ::base::File ts_data_in,
    ::base::File ts_sp_model_in,
    ::base::File language_detection_model_in)
    : weights(std::move(weights_in)),
      ts_data(std::move(ts_data_in)),
      ts_sp_model(std::move(ts_sp_model_in)),
      language_detection_model(std::move(language_detection_model_in)) {}

ModelAssets::~ModelAssets() = default;

void ModelAssets::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "weights"), this->weights,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::base::File>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "ts_data"), this->ts_data,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::base::File>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "ts_sp_model"), this->ts_sp_model,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::base::File>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "language_detection_model"), this->language_detection_model,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::base::File>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool ModelAssets::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
LoadModelParams::LoadModelParams()
    : assets(),
      max_tokens(),
      ts_dimension(),
      adaptation_ranks(),
      support_multiple_sessions() {}

LoadModelParams::LoadModelParams(
    ::on_device_model::ModelAssets assets_in,
    uint32_t max_tokens_in,
    std::optional<uint32_t> ts_dimension_in,
    std::vector<uint32_t> adaptation_ranks_in,
    bool support_multiple_sessions_in)
    : assets(std::move(assets_in)),
      max_tokens(std::move(max_tokens_in)),
      ts_dimension(std::move(ts_dimension_in)),
      adaptation_ranks(std::move(adaptation_ranks_in)),
      support_multiple_sessions(std::move(support_multiple_sessions_in)) {}

LoadModelParams::~LoadModelParams() = default;

void LoadModelParams::WriteIntoTrace(
    perfetto::TracedValue traced_context) const {
  [[maybe_unused]] auto dict = std::move(traced_context).WriteDictionary();
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "assets"), this->assets,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type ::on_device_model::ModelAssets>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "max_tokens"), this->max_tokens,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type uint32_t>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "ts_dimension"), this->ts_dimension,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type std::optional<uint32_t>>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "adaptation_ranks"), this->adaptation_ranks,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type const std::vector<uint32_t>&>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
  perfetto::WriteIntoTracedValueWithFallback(
    dict.AddItem(
      "support_multiple_sessions"), this->support_multiple_sessions,
#if BUILDFLAG(MOJO_TRACE_ENABLED)
      "<value of type bool>"
#else
      "<value>"
#endif  // BUILDFLAG(MOJO_TRACE_ENABLED)
    );
}

bool LoadModelParams::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  return Data_::Validate(data, validation_context);
}
const char OnDeviceModelService::Name_[] = "on_device_model.mojom.OnDeviceModelService";

OnDeviceModelService::IPCStableHashFunction OnDeviceModelService::MessageToMethodInfo_(mojo::Message& message) {
#if !BUILDFLAG(IS_FUCHSIA)
  switch (static_cast<messages::OnDeviceModelService>(message.name())) {
    case messages::OnDeviceModelService::kLoadModel: {
      return &OnDeviceModelService::LoadModel_Sym::IPCStableHash;
    }
    case messages::OnDeviceModelService::kGetEstimatedPerformanceClass: {
      return &OnDeviceModelService::GetEstimatedPerformanceClass_Sym::IPCStableHash;
    }
  }
#endif  // !BUILDFLAG(IS_FUCHSIA)
  return nullptr;
}


const char* OnDeviceModelService::MessageToMethodName_(mojo::Message& message) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (!is_response) {
    switch (static_cast<messages::OnDeviceModelService>(message.name())) {
      case messages::OnDeviceModelService::kLoadModel:
            return "Receive on_device_model::mojom::OnDeviceModelService::LoadModel";
      case messages::OnDeviceModelService::kGetEstimatedPerformanceClass:
            return "Receive on_device_model::mojom::OnDeviceModelService::GetEstimatedPerformanceClass";
    }
  } else {
    switch (static_cast<messages::OnDeviceModelService>(message.name())) {
      case messages::OnDeviceModelService::kLoadModel:
            return "Receive reply on_device_model::mojom::OnDeviceModelService::LoadModel";
      case messages::OnDeviceModelService::kGetEstimatedPerformanceClass:
            return "Receive reply on_device_model::mojom::OnDeviceModelService::GetEstimatedPerformanceClass";
    }
  }
  return "Receive unknown mojo message";
#else
  bool is_response = message.has_flag(mojo::Message::kFlagIsResponse);
  if (is_response) {
    return "Receive mojo reply";
  } else {
    return "Receive mojo message";
  }
#endif // BUILDFLAG(MOJO_TRACE_ENABLED)
}

#if !BUILDFLAG(IS_FUCHSIA)
uint32_t OnDeviceModelService::LoadModel_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)on_device_model::mojom::OnDeviceModelService::LoadModel");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
uint32_t OnDeviceModelService::GetEstimatedPerformanceClass_Sym::IPCStableHash() {
  // This method's address is used for indetifiying the mojo method name after
  // symbolization. So each IPCStableHash should have a unique address.
  // We cannot use NO_CODE_FOLDING() here - it relies on the uniqueness of
  // __LINE__ value, which is not unique accross different mojo modules.
  // The code below is very similar to NO_CODE_FOLDING, but it uses a unique
  // hash instead of __LINE__.
  constexpr uint32_t kHash = base::MD5Hash32Constexpr(
          "(Impl)on_device_model::mojom::OnDeviceModelService::GetEstimatedPerformanceClass");
  const uint32_t hash = kHash;
  base::debug::Alias(&hash);
  return hash;
}
# endif // !BUILDFLAG(IS_FUCHSIA)

class OnDeviceModelService_LoadModel_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  OnDeviceModelService_LoadModel_ForwardToCallback(
      OnDeviceModelService::LoadModelCallback callback
      ) : callback_(std::move(callback)) {
  }

  OnDeviceModelService_LoadModel_ForwardToCallback(const OnDeviceModelService_LoadModel_ForwardToCallback&) = delete;
  OnDeviceModelService_LoadModel_ForwardToCallback& operator=(const OnDeviceModelService_LoadModel_ForwardToCallback&) = delete;

  bool Accept(mojo::Message* message) override;
 private:
  OnDeviceModelService::LoadModelCallback callback_;
};

class OnDeviceModelService_GetEstimatedPerformanceClass_ForwardToCallback
    : public mojo::MessageReceiver {
 public:
  OnDeviceModelService_GetEstimatedPerformanceClass_ForwardToCallback(
      OnDeviceModelService::GetEstimatedPerformanceClassCallback callback
      ) : callback_(std::move(callback)) {
  }

  OnDeviceModelService_GetEstimatedPerformanceClass_ForwardToCallback(const OnDeviceModelService_GetEstimatedPerformanceClass_ForwardToCallback&) = delete;
  OnDeviceModelService_GetEstimatedPerformanceClass_ForwardToCallback& operator=(const OnDeviceModelService_GetEstimatedPerformanceClass_ForwardToCallback&) = delete;

  bool Accept(mojo::Message* message) override;
 private:
  OnDeviceModelService::GetEstimatedPerformanceClassCallback callback_;
};

OnDeviceModelServiceProxy::OnDeviceModelServiceProxy(mojo::MessageReceiverWithResponder* receiver)
    : receiver_(receiver) {
}

void OnDeviceModelServiceProxy::LoadModel(
    LoadModelParamsPtr in_params, ::mojo::PendingReceiver<::on_device_model::mojom::OnDeviceModel> in_model, LoadModelCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send on_device_model::mojom::OnDeviceModelService::LoadModel", "input_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("params"), in_params,
                        "<value of type LoadModelParamsPtr>");
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("model"), in_model,
                        "<value of type ::mojo::PendingReceiver<::on_device_model::mojom::OnDeviceModel>>");
   });
#endif

  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  const bool is_urgent = false;

  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((is_urgent) ? mojo::Message::kFlagIsUrgent : 0);

  const size_t estimated_payload_size =
    0;
  mojo::Message message(
      base::to_underlying(messages::OnDeviceModelService::kLoadModel), kFlags, estimated_payload_size);
  mojo::internal::MessageFragment<
      ::on_device_model::mojom::internal::OnDeviceModelService_LoadModel_Params_Data> params(
          message);
  params.Allocate();
  mojo::internal::MessageFragment<
      typename decltype(params->params)::BaseType> params_fragment(
          params.message());
  mojo::internal::Serialize<::on_device_model::mojom::LoadModelParamsDataView>(
      in_params, params_fragment);
  params->params.Set(
      params_fragment.is_null() ? nullptr : params_fragment.data());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      params->params.is_null(),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_NULL_POINTER,
      "null params in OnDeviceModelService.LoadModel request");
  mojo::internal::Serialize<mojo::InterfaceRequestDataView<::on_device_model::mojom::OnDeviceModelInterfaceBase>>(
      in_model, &params->model, &params.message());
  MOJO_INTERNAL_DLOG_SERIALIZATION_WARNING(
      !mojo::internal::IsHandleOrInterfaceValid(params->model),
      mojo::internal::VALIDATION_ERROR_UNEXPECTED_INVALID_HANDLE,
      "invalid model in OnDeviceModelService.LoadModel request");

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(OnDeviceModelService::Name_);
  message.set_method_name("LoadModel");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new OnDeviceModelService_LoadModel_ForwardToCallback(
          std::move(callback)));
  ::mojo::internal::SendMojoMessage(*receiver_, message, std::move(responder));
}

void OnDeviceModelServiceProxy::GetEstimatedPerformanceClass(
    GetEstimatedPerformanceClassCallback callback) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT0("mojom", "Send on_device_model::mojom::OnDeviceModelService::GetEstimatedPerformanceClass");
#endif

  const bool kExpectsResponse = true;
  const bool kIsSync = false;
  const bool kAllowInterrupt = true;
  const bool is_urgent = false;

  const uint32_t kFlags =
      ((kExpectsResponse) ? mojo::Message::kFlagExpectsResponse : 0) |
      ((kIsSync) ? mojo::Message::kFlagIsSync : 0) |
      ((kAllowInterrupt) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((is_urgent) ? mojo::Message::kFlagIsUrgent : 0);

  const size_t estimated_payload_size =
    0;
  mojo::Message message(
      base::to_underlying(messages::OnDeviceModelService::kGetEstimatedPerformanceClass), kFlags, estimated_payload_size);
  mojo::internal::MessageFragment<
      ::on_device_model::mojom::internal::OnDeviceModelService_GetEstimatedPerformanceClass_Params_Data> params(
          message);
  params.Allocate();

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(OnDeviceModelService::Name_);
  message.set_method_name("GetEstimatedPerformanceClass");
#endif
  std::unique_ptr<mojo::MessageReceiver> responder(
      new OnDeviceModelService_GetEstimatedPerformanceClass_ForwardToCallback(
          std::move(callback)));
  ::mojo::internal::SendMojoMessage(*receiver_, message, std::move(responder));
}
class OnDeviceModelService_LoadModel_ProxyToResponder : public ::mojo::internal::ProxyToResponder {
 public:
  static OnDeviceModelService::LoadModelCallback CreateCallback(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<OnDeviceModelService_LoadModel_ProxyToResponder> proxy(
        new OnDeviceModelService_LoadModel_ProxyToResponder(
            message, std::move(responder)));
    return base::BindOnce(&OnDeviceModelService_LoadModel_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~OnDeviceModelService_LoadModel_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      // Instantiate a ScopedFizzleBlockShutdownTasks to allow this request to
      // fizzle if this happens after shutdown and the endpoint is bound to a
      // BLOCK_SHUTDOWN sequence.
      base::ThreadPoolInstance::ScopedFizzleBlockShutdownTasks fizzler;
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
  }

 private:
  OnDeviceModelService_LoadModel_ProxyToResponder(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : ::mojo::internal::ProxyToResponder(message, std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "OnDeviceModelService::LoadModelCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      ::on_device_model::mojom::LoadModelResult in_result);
};

bool OnDeviceModelService_LoadModel_ForwardToCallback::Accept(
    mojo::Message* message) {
  DCHECK(message->is_serialized());
  internal::OnDeviceModelService_LoadModel_ResponseParams_Data* params =
      reinterpret_cast<
          internal::OnDeviceModelService_LoadModel_ResponseParams_Data*>(
              message->mutable_payload());
  
  
  // Validation for OnDeviceModelService.0
  bool success = true;
  ::on_device_model::mojom::LoadModelResult p_result{};
  OnDeviceModelService_LoadModel_ResponseParamsDataView input_data_view(params, message);
  
  if (success && !input_data_view.ReadResult(&p_result))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        OnDeviceModelService::Name_, 0, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_result));
  return true;
}

void OnDeviceModelService_LoadModel_ProxyToResponder::Run(
    ::on_device_model::mojom::LoadModelResult in_result) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send reply on_device_model::mojom::OnDeviceModelService::LoadModel", "async_response_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("result"), in_result,
                        "<value of type ::on_device_model::mojom::LoadModelResult>");
   });
#endif

  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0) |
      ((true) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((false) ? mojo::Message::kFlagIsUrgent : 0);

  const size_t estimated_payload_size =
    0;
  mojo::Message message(
      base::to_underlying(messages::OnDeviceModelService::kLoadModel), kFlags, estimated_payload_size);
  mojo::internal::MessageFragment<
      ::on_device_model::mojom::internal::OnDeviceModelService_LoadModel_ResponseParams_Data> params(
          message);
  params.Allocate();
  mojo::internal::Serialize<::on_device_model::mojom::LoadModelResult>(
      in_result, &params->result);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(OnDeviceModelService::Name_);
  message.set_method_name("LoadModel");
#endif

  message.set_request_id(request_id_);
  message.set_trace_nonce(trace_nonce_);
  ::mojo::internal::SendMojoMessage(*responder_, message);
  // SendMojoMessage() fails silently if the responder connection is closed,
  // or if the message is malformed.
  //
  // TODO(darin): If Accept() returns false due to a malformed message, that
  // may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}
class OnDeviceModelService_GetEstimatedPerformanceClass_ProxyToResponder : public ::mojo::internal::ProxyToResponder {
 public:
  static OnDeviceModelService::GetEstimatedPerformanceClassCallback CreateCallback(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
    std::unique_ptr<OnDeviceModelService_GetEstimatedPerformanceClass_ProxyToResponder> proxy(
        new OnDeviceModelService_GetEstimatedPerformanceClass_ProxyToResponder(
            message, std::move(responder)));
    return base::BindOnce(&OnDeviceModelService_GetEstimatedPerformanceClass_ProxyToResponder::Run,
                          std::move(proxy));
  }

  ~OnDeviceModelService_GetEstimatedPerformanceClass_ProxyToResponder() {
#if DCHECK_IS_ON()
    if (responder_) {
      // If we're being destroyed without being run, we want to ensure the
      // binding endpoint has been closed. This checks for that asynchronously.
      // We pass a bound generated callback to handle the response so that any
      // resulting DCHECK stack will have useful interface type information.
      // Instantiate a ScopedFizzleBlockShutdownTasks to allow this request to
      // fizzle if this happens after shutdown and the endpoint is bound to a
      // BLOCK_SHUTDOWN sequence.
      base::ThreadPoolInstance::ScopedFizzleBlockShutdownTasks fizzler;
      responder_->IsConnectedAsync(base::BindOnce(&OnIsConnectedComplete));
    }
#endif
  }

 private:
  OnDeviceModelService_GetEstimatedPerformanceClass_ProxyToResponder(
      ::mojo::Message& message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder)
      : ::mojo::internal::ProxyToResponder(message, std::move(responder)) {
  }

#if DCHECK_IS_ON()
  static void OnIsConnectedComplete(bool connected) {
    DCHECK(!connected)
        << "OnDeviceModelService::GetEstimatedPerformanceClassCallback was destroyed without "
        << "first either being run or its corresponding binding being closed. "
        << "It is an error to drop response callbacks which still correspond "
        << "to an open interface pipe.";
  }
#endif

  void Run(
      ::on_device_model::mojom::PerformanceClass in_performance_class);
};

bool OnDeviceModelService_GetEstimatedPerformanceClass_ForwardToCallback::Accept(
    mojo::Message* message) {
  DCHECK(message->is_serialized());
  internal::OnDeviceModelService_GetEstimatedPerformanceClass_ResponseParams_Data* params =
      reinterpret_cast<
          internal::OnDeviceModelService_GetEstimatedPerformanceClass_ResponseParams_Data*>(
              message->mutable_payload());
  
  
  // Validation for OnDeviceModelService.1
  bool success = true;
  ::on_device_model::mojom::PerformanceClass p_performance_class{};
  OnDeviceModelService_GetEstimatedPerformanceClass_ResponseParamsDataView input_data_view(params, message);
  
  if (success && !input_data_view.ReadPerformanceClass(&p_performance_class))
    success = false;
  if (!success) {
    ReportValidationErrorForMessage(
        message,
        mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
        OnDeviceModelService::Name_, 1, true);
    return false;
  }
  if (!callback_.is_null())
    std::move(callback_).Run(
std::move(p_performance_class));
  return true;
}

void OnDeviceModelService_GetEstimatedPerformanceClass_ProxyToResponder::Run(
    ::on_device_model::mojom::PerformanceClass in_performance_class) {
#if BUILDFLAG(MOJO_TRACE_ENABLED)
  TRACE_EVENT1(
    "mojom", "Send reply on_device_model::mojom::OnDeviceModelService::GetEstimatedPerformanceClass", "async_response_parameters",
    [&](perfetto::TracedValue context){
      auto dict = std::move(context).WriteDictionary();
      perfetto::WriteIntoTracedValueWithFallback(
           dict.AddItem("performance_class"), in_performance_class,
                        "<value of type ::on_device_model::mojom::PerformanceClass>");
   });
#endif

  const uint32_t kFlags = mojo::Message::kFlagIsResponse |
      ((is_sync_) ? mojo::Message::kFlagIsSync : 0) |
      ((true) ? 0 : mojo::Message::kFlagNoInterrupt) |
      ((false) ? mojo::Message::kFlagIsUrgent : 0);

  const size_t estimated_payload_size =
    0;
  mojo::Message message(
      base::to_underlying(messages::OnDeviceModelService::kGetEstimatedPerformanceClass), kFlags, estimated_payload_size);
  mojo::internal::MessageFragment<
      ::on_device_model::mojom::internal::OnDeviceModelService_GetEstimatedPerformanceClass_ResponseParams_Data> params(
          message);
  params.Allocate();
  mojo::internal::Serialize<::on_device_model::mojom::PerformanceClass>(
      in_performance_class, &params->performance_class);

#if defined(ENABLE_IPC_FUZZER)
  message.set_interface_name(OnDeviceModelService::Name_);
  message.set_method_name("GetEstimatedPerformanceClass");
#endif

  message.set_request_id(request_id_);
  message.set_trace_nonce(trace_nonce_);
  ::mojo::internal::SendMojoMessage(*responder_, message);
  // SendMojoMessage() fails silently if the responder connection is closed,
  // or if the message is malformed.
  //
  // TODO(darin): If Accept() returns false due to a malformed message, that
  // may be good reason to close the connection. However, we don't have a
  // way to do that from here. We should add a way.
  responder_ = nullptr;
}

// static
bool OnDeviceModelServiceStubDispatch::Accept(
    OnDeviceModelService* impl,
    mojo::Message* message) {
  switch (static_cast<messages::OnDeviceModelService>(message->header()->name)) {
    case messages::OnDeviceModelService::kLoadModel: {
      break;
    }
    case messages::OnDeviceModelService::kGetEstimatedPerformanceClass: {
      break;
    }
  }
  return false;
}

// static
bool OnDeviceModelServiceStubDispatch::AcceptWithResponder(
    OnDeviceModelService* impl,
    mojo::Message* message,
    std::unique_ptr<mojo::MessageReceiverWithStatus> responder) {
  [[maybe_unused]] const bool message_is_sync =
      message->has_flag(mojo::Message::kFlagIsSync);
  [[maybe_unused]] const uint64_t request_id = message->request_id();
  switch (static_cast<messages::OnDeviceModelService>(message->header()->name)) {
    case messages::OnDeviceModelService::kLoadModel: {
      internal::OnDeviceModelService_LoadModel_Params_Data* params =
          reinterpret_cast<
              internal::OnDeviceModelService_LoadModel_Params_Data*>(
                  message->mutable_payload());
      
      
      // Validation for OnDeviceModelService.0
      bool success = true;
      LoadModelParamsPtr p_params{};
      ::mojo::PendingReceiver<::on_device_model::mojom::OnDeviceModel> p_model{};
      OnDeviceModelService_LoadModel_ParamsDataView input_data_view(params, message);
      
      if (success && !input_data_view.ReadParams(&p_params))
        success = false;
      if (success) {
        p_model =
            input_data_view.TakeModel<decltype(p_model)>();
      }
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            OnDeviceModelService::Name_, 0, false);
        return false;
      }
      OnDeviceModelService::LoadModelCallback callback =
          OnDeviceModelService_LoadModel_ProxyToResponder::CreateCallback(
              *message, std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->LoadModel(        
        std::move(p_params), 
        std::move(p_model), std::move(callback));
      return true;
    }
    case messages::OnDeviceModelService::kGetEstimatedPerformanceClass: {
      internal::OnDeviceModelService_GetEstimatedPerformanceClass_Params_Data* params =
          reinterpret_cast<
              internal::OnDeviceModelService_GetEstimatedPerformanceClass_Params_Data*>(
                  message->mutable_payload());
      
      
      // Validation for OnDeviceModelService.1
      bool success = true;
      OnDeviceModelService_GetEstimatedPerformanceClass_ParamsDataView input_data_view(params, message);
      
      if (!success) {
        ReportValidationErrorForMessage(
            message,
            mojo::internal::VALIDATION_ERROR_DESERIALIZATION_FAILED,
            OnDeviceModelService::Name_, 1, false);
        return false;
      }
      OnDeviceModelService::GetEstimatedPerformanceClassCallback callback =
          OnDeviceModelService_GetEstimatedPerformanceClass_ProxyToResponder::CreateCallback(
              *message, std::move(responder));
      // A null |impl| means no implementation was bound.
      DCHECK(impl);
      impl->GetEstimatedPerformanceClass(std::move(callback));
      return true;
    }
  }
  return false;
}
namespace {
}  // namespace
static const std::pair<uint32_t, mojo::internal::GenericValidationInfo> kOnDeviceModelServiceValidationInfo[] = {
    {base::to_underlying(messages::OnDeviceModelService::kLoadModel),
     { &internal::OnDeviceModelService_LoadModel_Params_Data::Validate,
      &internal::OnDeviceModelService_LoadModel_ResponseParams_Data::Validate}},
    {base::to_underlying(messages::OnDeviceModelService::kGetEstimatedPerformanceClass),
     { &internal::OnDeviceModelService_GetEstimatedPerformanceClass_Params_Data::Validate,
      &internal::OnDeviceModelService_GetEstimatedPerformanceClass_ResponseParams_Data::Validate}},
};

bool OnDeviceModelServiceRequestValidator::Accept(mojo::Message* message) {
  const char* name = ::on_device_model::mojom::OnDeviceModelService::Name_;
  return mojo::internal::ValidateRequestGeneric(message, name, kOnDeviceModelServiceValidationInfo);
}

bool OnDeviceModelServiceResponseValidator::Accept(mojo::Message* message) {
  const char* name = ::on_device_model::mojom::OnDeviceModelService::Name_;
  return mojo::internal::ValidateResponseGeneric(message, name, kOnDeviceModelServiceValidationInfo);

}


}  // on_device_model::mojom


namespace mojo {


// static
bool StructTraits<::on_device_model::mojom::ModelAssets::DataView, ::on_device_model::mojom::ModelAssetsPtr>::Read(
    ::on_device_model::mojom::ModelAssets::DataView input,
    ::on_device_model::mojom::ModelAssetsPtr* output) {
  bool success = true;
  ::on_device_model::mojom::ModelAssetsPtr result(::on_device_model::mojom::ModelAssets::New());
  
      if (success && !input.ReadWeights(&result->weights))
        success = false;
      if (success && !input.ReadTsData(&result->ts_data))
        success = false;
      if (success && !input.ReadTsSpModel(&result->ts_sp_model))
        success = false;
      if (success && !input.ReadLanguageDetectionModel(&result->language_detection_model))
        success = false;
  *output = std::move(result);
  return success;
}


// static
bool StructTraits<::on_device_model::mojom::LoadModelParams::DataView, ::on_device_model::mojom::LoadModelParamsPtr>::Read(
    ::on_device_model::mojom::LoadModelParams::DataView input,
    ::on_device_model::mojom::LoadModelParamsPtr* output) {
  bool success = true;
  ::on_device_model::mojom::LoadModelParamsPtr result(::on_device_model::mojom::LoadModelParams::New());
  
      if (success && !input.ReadAssets(&result->assets))
        success = false;
      if (success)
        result->max_tokens = input.max_tokens();
      if (success) {
        result->ts_dimension = input.ts_dimension();
      }
      if (success && !input.ReadAdaptationRanks(&result->adaptation_ranks))
        success = false;
      if (success)
        result->support_multiple_sessions = input.support_multiple_sessions();
  *output = std::move(result);
  return success;
}

}  // namespace mojo


// Symbols declared in the -test-utils.h header are defined here instead of a
// separate .cc file to save compile time.


namespace on_device_model::mojom {


void OnDeviceModelServiceInterceptorForTesting::LoadModel(LoadModelParamsPtr params, ::mojo::PendingReceiver<::on_device_model::mojom::OnDeviceModel> model, LoadModelCallback callback) {
  GetForwardingInterface()->LoadModel(
    std::move(params)
    , 
    std::move(model)
    , std::move(callback));
}
void OnDeviceModelServiceInterceptorForTesting::GetEstimatedPerformanceClass(GetEstimatedPerformanceClassCallback callback) {
  GetForwardingInterface()->GetEstimatedPerformanceClass(std::move(callback));
}
OnDeviceModelServiceAsyncWaiter::OnDeviceModelServiceAsyncWaiter(
    OnDeviceModelService* proxy) : proxy_(proxy) {}

OnDeviceModelServiceAsyncWaiter::~OnDeviceModelServiceAsyncWaiter() = default;

void OnDeviceModelServiceAsyncWaiter::LoadModel(
    LoadModelParamsPtr params, ::mojo::PendingReceiver<::on_device_model::mojom::OnDeviceModel> model, ::on_device_model::mojom::LoadModelResult* out_result) {
  base::RunLoop loop;
  proxy_->LoadModel(std::move(params),std::move(model),
      base::BindOnce(
          [](base::RunLoop* loop,
             ::on_device_model::mojom::LoadModelResult* out_result
,
             ::on_device_model::mojom::LoadModelResult result) {*out_result = std::move(result);
            loop->Quit();
          },
          &loop,
          out_result));
  loop.Run();
}

::on_device_model::mojom::LoadModelResult OnDeviceModelServiceAsyncWaiter::LoadModel(
    LoadModelParamsPtr params, ::mojo::PendingReceiver<::on_device_model::mojom::OnDeviceModel> model) {
  ::on_device_model::mojom::LoadModelResult async_wait_result;
  LoadModel(std::move(params),std::move(model),&async_wait_result);
  return async_wait_result;
}

void OnDeviceModelServiceAsyncWaiter::GetEstimatedPerformanceClass(
    ::on_device_model::mojom::PerformanceClass* out_performance_class) {
  base::RunLoop loop;
  proxy_->GetEstimatedPerformanceClass(
      base::BindOnce(
          [](base::RunLoop* loop,
             ::on_device_model::mojom::PerformanceClass* out_performance_class
,
             ::on_device_model::mojom::PerformanceClass performance_class) {*out_performance_class = std::move(performance_class);
            loop->Quit();
          },
          &loop,
          out_performance_class));
  loop.Run();
}

::on_device_model::mojom::PerformanceClass OnDeviceModelServiceAsyncWaiter::GetEstimatedPerformanceClass(
    ) {
  ::on_device_model::mojom::PerformanceClass async_wait_result;
  GetEstimatedPerformanceClass(&async_wait_result);
  return async_wait_result;
}






}  // on_device_model::mojom


#if defined(__clang__)
#pragma clang diagnostic pop
#endif