// services/on_device_model/public/mojom/on_device_model_service.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef SERVICES_ON_DEVICE_MODEL_PUBLIC_MOJOM_ON_DEVICE_MODEL_SERVICE_MOJOM_H_
#define SERVICES_ON_DEVICE_MODEL_PUBLIC_MOJOM_ON_DEVICE_MODEL_SERVICE_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "services/on_device_model/public/mojom/on_device_model_service.mojom-features.h"
#include "services/on_device_model/public/mojom/on_device_model_service.mojom-shared.h"
#include "services/on_device_model/public/mojom/on_device_model_service.mojom-forward.h"
#include "mojo/public/mojom/base/file.mojom.h"
#include "mojo/public/mojom/base/read_only_file.mojom.h"
#include "mojo/public/mojom/base/uuid.mojom-forward.h"
#include "sandbox/policy/mojom/context.mojom-forward.h"
#include "sandbox/policy/mojom/sandbox.mojom-forward.h"
#include "services/on_device_model/public/mojom/on_device_model.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "services/on_device_model/public/cpp/adaptation_assets_mojom_traits.h"
#include "services/on_device_model/public/cpp/model_assets_mojom_traits.h"




namespace on_device_model::mojom {

class OnDeviceModelServiceProxy;

template <typename ImplRefTraits>
class OnDeviceModelServiceStub;

class OnDeviceModelServiceRequestValidator;
class OnDeviceModelServiceResponseValidator;


class OnDeviceModelService
    : public OnDeviceModelServiceInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr auto kServiceSandbox = sandbox::mojom::Sandbox::kOnDeviceModelExecution;
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = OnDeviceModelServiceInterfaceBase;
  using Proxy_ = OnDeviceModelServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = OnDeviceModelServiceStub<ImplRefTraits>;

  using RequestValidator_ = OnDeviceModelServiceRequestValidator;
  using ResponseValidator_ = OnDeviceModelServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kLoadModelMinVersion = 0,
    kGetEstimatedPerformanceClassMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct LoadModel_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct GetEstimatedPerformanceClass_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~OnDeviceModelService() = default;


  using LoadModelCallback = base::OnceCallback<void(::on_device_model::mojom::LoadModelResult)>;
  
  virtual void LoadModel(LoadModelParamsPtr params, ::mojo::PendingReceiver<::on_device_model::mojom::OnDeviceModel> model, LoadModelCallback callback) = 0;


  using GetEstimatedPerformanceClassCallback = base::OnceCallback<void(::on_device_model::mojom::PerformanceClass)>;
  
  virtual void GetEstimatedPerformanceClass(GetEstimatedPerformanceClassCallback callback) = 0;
};



class  OnDeviceModelServiceProxy
    : public OnDeviceModelService {
 public:
  using InterfaceType = OnDeviceModelService;

  explicit OnDeviceModelServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void LoadModel(LoadModelParamsPtr params, ::mojo::PendingReceiver<::on_device_model::mojom::OnDeviceModel> model, LoadModelCallback callback) final;
  
  void GetEstimatedPerformanceClass(GetEstimatedPerformanceClassCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class  OnDeviceModelServiceStubDispatch {
 public:
  static bool Accept(OnDeviceModelService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      OnDeviceModelService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<OnDeviceModelService>>
class OnDeviceModelServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  OnDeviceModelServiceStub() = default;
  ~OnDeviceModelServiceStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OnDeviceModelServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return OnDeviceModelServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class  OnDeviceModelServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class  OnDeviceModelServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};









class  ModelAssets {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<ModelAssets, T>::value>;
  using DataView = ModelAssetsDataView;
  using Data_ = internal::ModelAssets_Data;

  template <typename... Args>
  static ModelAssetsPtr New(Args&&... args) {
    return ModelAssetsPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static ModelAssetsPtr From(const U& u) {
    return mojo::TypeConverter<ModelAssetsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, ModelAssets>::Convert(*this);
  }


  ModelAssets();

  ModelAssets(
      ::base::File weights,
      ::base::File ts_data,
      ::base::File ts_sp_model,
      ::base::File language_detection_model);

ModelAssets(const ModelAssets&) = delete;
ModelAssets& operator=(const ModelAssets&) = delete;

  ~ModelAssets();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = ModelAssetsPtr>
  ModelAssetsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, ModelAssets::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, ModelAssets::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, ModelAssets::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        ModelAssets::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::ModelAssets_UnserializedMessageContext<
            UserType, ModelAssets::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<ModelAssets::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return ModelAssets::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::ModelAssets_UnserializedMessageContext<
            UserType, ModelAssets::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<ModelAssets::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::base::File weights;
  
  ::base::File ts_data;
  
  ::base::File ts_sp_model;
  
  ::base::File language_detection_model;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, ModelAssets::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, ModelAssets::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, ModelAssets::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, ModelAssets::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}





class  LoadModelParams {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<LoadModelParams, T>::value>;
  using DataView = LoadModelParamsDataView;
  using Data_ = internal::LoadModelParams_Data;

  template <typename... Args>
  static LoadModelParamsPtr New(Args&&... args) {
    return LoadModelParamsPtr(
        std::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static LoadModelParamsPtr From(const U& u) {
    return mojo::TypeConverter<LoadModelParamsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, LoadModelParams>::Convert(*this);
  }


  LoadModelParams();

  LoadModelParams(
      ::on_device_model::ModelAssets assets,
      uint32_t max_tokens,
      std::optional<uint32_t> ts_dimension,
      std::vector<uint32_t> adaptation_ranks,
      bool support_multiple_sessions);

LoadModelParams(const LoadModelParams&) = delete;
LoadModelParams& operator=(const LoadModelParams&) = delete;

  ~LoadModelParams();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = LoadModelParamsPtr>
  LoadModelParamsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, LoadModelParams::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, LoadModelParams::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }

  template <typename T, LoadModelParams::EnableIfSame<T>* = nullptr>
  bool operator!=(const T& rhs) const { return !operator==(rhs); }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        LoadModelParams::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::LoadModelParams_UnserializedMessageContext<
            UserType, LoadModelParams::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<LoadModelParams::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return LoadModelParams::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::LoadModelParams_UnserializedMessageContext<
            UserType, LoadModelParams::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<LoadModelParams::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  ::on_device_model::ModelAssets assets;
  
  uint32_t max_tokens;
  
  std::optional<uint32_t> ts_dimension;
  
  std::vector<uint32_t> adaptation_ranks;
  
  bool support_multiple_sessions;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, LoadModelParams::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, LoadModelParams::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, LoadModelParams::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, LoadModelParams::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
ModelAssetsPtr ModelAssets::Clone() const {
  return New(
      mojo::Clone(weights),
      mojo::Clone(ts_data),
      mojo::Clone(ts_sp_model),
      mojo::Clone(language_detection_model)
  );
}

template <typename T, ModelAssets::EnableIfSame<T>*>
bool ModelAssets::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->weights, other_struct.weights))
    return false;
  if (!mojo::Equals(this->ts_data, other_struct.ts_data))
    return false;
  if (!mojo::Equals(this->ts_sp_model, other_struct.ts_sp_model))
    return false;
  if (!mojo::Equals(this->language_detection_model, other_struct.language_detection_model))
    return false;
  return true;
}

template <typename T, ModelAssets::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.weights < rhs.weights)
    return true;
  if (rhs.weights < lhs.weights)
    return false;
  if (lhs.ts_data < rhs.ts_data)
    return true;
  if (rhs.ts_data < lhs.ts_data)
    return false;
  if (lhs.ts_sp_model < rhs.ts_sp_model)
    return true;
  if (rhs.ts_sp_model < lhs.ts_sp_model)
    return false;
  if (lhs.language_detection_model < rhs.language_detection_model)
    return true;
  if (rhs.language_detection_model < lhs.language_detection_model)
    return false;
  return false;
}
template <typename StructPtrType>
LoadModelParamsPtr LoadModelParams::Clone() const {
  return New(
      mojo::Clone(assets),
      mojo::Clone(max_tokens),
      mojo::Clone(ts_dimension),
      mojo::Clone(adaptation_ranks),
      mojo::Clone(support_multiple_sessions)
  );
}

template <typename T, LoadModelParams::EnableIfSame<T>*>
bool LoadModelParams::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->assets, other_struct.assets))
    return false;
  if (!mojo::Equals(this->max_tokens, other_struct.max_tokens))
    return false;
  if (!mojo::Equals(this->ts_dimension, other_struct.ts_dimension))
    return false;
  if (!mojo::Equals(this->adaptation_ranks, other_struct.adaptation_ranks))
    return false;
  if (!mojo::Equals(this->support_multiple_sessions, other_struct.support_multiple_sessions))
    return false;
  return true;
}

template <typename T, LoadModelParams::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.assets < rhs.assets)
    return true;
  if (rhs.assets < lhs.assets)
    return false;
  if (lhs.max_tokens < rhs.max_tokens)
    return true;
  if (rhs.max_tokens < lhs.max_tokens)
    return false;
  if (lhs.ts_dimension < rhs.ts_dimension)
    return true;
  if (rhs.ts_dimension < lhs.ts_dimension)
    return false;
  if (lhs.adaptation_ranks < rhs.adaptation_ranks)
    return true;
  if (rhs.adaptation_ranks < lhs.adaptation_ranks)
    return false;
  if (lhs.support_multiple_sessions < rhs.support_multiple_sessions)
    return true;
  if (rhs.support_multiple_sessions < lhs.support_multiple_sessions)
    return false;
  return false;
}


}  // on_device_model::mojom

namespace mojo {


template <>
struct  StructTraits<::on_device_model::mojom::ModelAssets::DataView,
                                         ::on_device_model::mojom::ModelAssetsPtr> {
  static bool IsNull(const ::on_device_model::mojom::ModelAssetsPtr& input) { return !input; }
  static void SetToNull(::on_device_model::mojom::ModelAssetsPtr* output) { output->reset(); }

  static  decltype(::on_device_model::mojom::ModelAssets::weights)& weights(
       ::on_device_model::mojom::ModelAssetsPtr& input) {
    return input->weights;
  }

  static  decltype(::on_device_model::mojom::ModelAssets::ts_data)& ts_data(
       ::on_device_model::mojom::ModelAssetsPtr& input) {
    return input->ts_data;
  }

  static  decltype(::on_device_model::mojom::ModelAssets::ts_sp_model)& ts_sp_model(
       ::on_device_model::mojom::ModelAssetsPtr& input) {
    return input->ts_sp_model;
  }

  static  decltype(::on_device_model::mojom::ModelAssets::language_detection_model)& language_detection_model(
       ::on_device_model::mojom::ModelAssetsPtr& input) {
    return input->language_detection_model;
  }

  static bool Read(::on_device_model::mojom::ModelAssets::DataView input, ::on_device_model::mojom::ModelAssetsPtr* output);
};


template <>
struct  StructTraits<::on_device_model::mojom::LoadModelParams::DataView,
                                         ::on_device_model::mojom::LoadModelParamsPtr> {
  static bool IsNull(const ::on_device_model::mojom::LoadModelParamsPtr& input) { return !input; }
  static void SetToNull(::on_device_model::mojom::LoadModelParamsPtr* output) { output->reset(); }

  static  decltype(::on_device_model::mojom::LoadModelParams::assets)& assets(
       ::on_device_model::mojom::LoadModelParamsPtr& input) {
    return input->assets;
  }

  static decltype(::on_device_model::mojom::LoadModelParams::max_tokens) max_tokens(
      const ::on_device_model::mojom::LoadModelParamsPtr& input) {
    return input->max_tokens;
  }

  static decltype(::on_device_model::mojom::LoadModelParams::ts_dimension) ts_dimension(
      const ::on_device_model::mojom::LoadModelParamsPtr& input) {
    return input->ts_dimension;
  }

  static const decltype(::on_device_model::mojom::LoadModelParams::adaptation_ranks)& adaptation_ranks(
      const ::on_device_model::mojom::LoadModelParamsPtr& input) {
    return input->adaptation_ranks;
  }

  static decltype(::on_device_model::mojom::LoadModelParams::support_multiple_sessions) support_multiple_sessions(
      const ::on_device_model::mojom::LoadModelParamsPtr& input) {
    return input->support_multiple_sessions;
  }

  static bool Read(::on_device_model::mojom::LoadModelParams::DataView input, ::on_device_model::mojom::LoadModelParamsPtr* output);
};

}  // namespace mojo

#endif  // SERVICES_ON_DEVICE_MODEL_PUBLIC_MOJOM_ON_DEVICE_MODEL_SERVICE_MOJOM_H_