// third_party/blink/public/mojom/webid/federated_auth_request_automation.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBID_FEDERATED_AUTH_REQUEST_AUTOMATION_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBID_FEDERATED_AUTH_REQUEST_AUTOMATION_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <optional>
#include <type_traits>
#include <utility>

#include "base/types/cxx23_to_underlying.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/webid/federated_auth_request_automation.mojom-features.h"
#include "third_party/blink/public/mojom/webid/federated_auth_request_automation.mojom-shared.h"
#include "third_party/blink/public/mojom/webid/federated_auth_request_automation.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/lib/message_size_estimator.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink::test::mojom {

class FederatedAuthRequestAutomationProxy;

template <typename ImplRefTraits>
class FederatedAuthRequestAutomationStub;

class FederatedAuthRequestAutomationRequestValidator;
class FederatedAuthRequestAutomationResponseValidator;


class BLINK_COMMON_EXPORT FederatedAuthRequestAutomation
    : public FederatedAuthRequestAutomationInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = FederatedAuthRequestAutomationInterfaceBase;
  using Proxy_ = FederatedAuthRequestAutomationProxy;

  template <typename ImplRefTraits>
  using Stub_ = FederatedAuthRequestAutomationStub<ImplRefTraits>;

  using RequestValidator_ = FederatedAuthRequestAutomationRequestValidator;
  using ResponseValidator_ = FederatedAuthRequestAutomationResponseValidator;
  enum MethodMinVersions : uint32_t {
    kGetDialogTypeMinVersion = 0,
    kGetFedCmDialogTitleMinVersion = 0,
    kSelectFedCmAccountMinVersion = 0,
    kDismissFedCmDialogMinVersion = 0,
    kClickFedCmDialogButtonMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct GetDialogType_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct GetFedCmDialogTitle_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct SelectFedCmAccount_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct DismissFedCmDialog_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct ClickFedCmDialogButton_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~FederatedAuthRequestAutomation() = default;


  using GetDialogTypeCallback = base::OnceCallback<void(const std::optional<std::string>&)>;
  
  virtual void GetDialogType(GetDialogTypeCallback callback) = 0;


  using GetFedCmDialogTitleCallback = base::OnceCallback<void(const std::optional<std::string>&)>;
  
  virtual void GetFedCmDialogTitle(GetFedCmDialogTitleCallback callback) = 0;


  using SelectFedCmAccountCallback = base::OnceCallback<void(bool)>;
  
  virtual void SelectFedCmAccount(uint32_t account_index, SelectFedCmAccountCallback callback) = 0;


  using DismissFedCmDialogCallback = base::OnceCallback<void(bool)>;
  
  virtual void DismissFedCmDialog(DismissFedCmDialogCallback callback) = 0;


  using ClickFedCmDialogButtonCallback = base::OnceCallback<void(bool)>;
  
  virtual void ClickFedCmDialogButton(DialogButton dialog_button, ClickFedCmDialogButtonCallback callback) = 0;
};



class BLINK_COMMON_EXPORT FederatedAuthRequestAutomationProxy
    : public FederatedAuthRequestAutomation {
 public:
  using InterfaceType = FederatedAuthRequestAutomation;

  explicit FederatedAuthRequestAutomationProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void GetDialogType(GetDialogTypeCallback callback) final;
  
  void GetFedCmDialogTitle(GetFedCmDialogTitleCallback callback) final;
  
  void SelectFedCmAccount(uint32_t account_index, SelectFedCmAccountCallback callback) final;
  
  void DismissFedCmDialog(DismissFedCmDialogCallback callback) final;
  
  void ClickFedCmDialogButton(DialogButton dialog_button, ClickFedCmDialogButtonCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT FederatedAuthRequestAutomationStubDispatch {
 public:
  static bool Accept(FederatedAuthRequestAutomation* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      FederatedAuthRequestAutomation* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<FederatedAuthRequestAutomation>>
class FederatedAuthRequestAutomationStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  FederatedAuthRequestAutomationStub() = default;
  ~FederatedAuthRequestAutomationStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FederatedAuthRequestAutomationStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return FederatedAuthRequestAutomationStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT FederatedAuthRequestAutomationRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT FederatedAuthRequestAutomationResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};





}  // blink::test::mojom

namespace mojo {

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_WEBID_FEDERATED_AUTH_REQUEST_AUTOMATION_MOJOM_H_