// ui/webui/resources/cr_components/customize_themes/customize_themes.mojom-shared.cc is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#include "ui/webui/resources/cr_components/customize_themes/customize_themes.mojom-shared.h"

// Used to support stream output operator for enums.
// TODO(dcheng): Consider omitting this somehow if not needed.
#include <ostream>
#include <utility>

#include "base/strings/stringprintf.h"
#include "mojo/public/cpp/bindings/lib/validate_params.h"
#include "mojo/public/cpp/bindings/lib/validation_errors.h"
#include "mojo/public/cpp/bindings/lib/validation_util.h"
#include "third_party/perfetto/include/perfetto/tracing/traced_value.h"

#include "ui/webui/resources/cr_components/customize_themes/customize_themes.mojom-params-data.h"
namespace customize_themes {
namespace mojom {

NOINLINE static const char* ThemeTypeToStringHelper(ThemeType value) {
  // Defined in a helper function to ensure that Clang generates a lookup table.
  switch(value) {
    case ThemeType::kDefault:
      return "kDefault";
    case ThemeType::kAutogenerated:
      return "kAutogenerated";
    case ThemeType::kChrome:
      return "kChrome";
    case ThemeType::kThirdParty:
      return "kThirdParty";
    default:
      return nullptr;
  }
}

std::string ThemeTypeToString(ThemeType value) {
  const char *str = ThemeTypeToStringHelper(value);
  if (!str) {
    return base::StringPrintf("Unknown ThemeType value: %i", static_cast<int32_t>(value));
  }
  return str;
}

std::ostream& operator<<(std::ostream& os, ThemeType value) {
  return os << ThemeTypeToString(value);
}

namespace internal {
// static
bool ThemeInfo_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context,
    bool inlined) {
  if (!data) {
    DCHECK(!inlined);
    return true;
  }

  // If it is inlined, the alignment is already enforced by its enclosing
  // object. We don't have to validate that.
  DCHECK(!inlined || mojo::internal::IsAligned(data));

  if (!inlined &&
      !mojo::internal::ValidateNonInlinedUnionHeaderAndClaimMemory(
          data, validation_context)) {
    return false;
  }

  const ThemeInfo_Data* object = static_cast<const ThemeInfo_Data*>(data);

  if (inlined && object->is_null())
    return true;

  switch (object->tag) {

    case ThemeInfo_Tag::kChromeThemeId: {

      return true;
    }
    case ThemeInfo_Tag::kAutogeneratedThemeColors: {

      if (!mojo::internal::ValidatePointerNonNullable(
              object->data.f_autogenerated_theme_colors, 2, validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateStruct(object->data.f_autogenerated_theme_colors, validation_context))
        return false;
      return true;
    }
    case ThemeInfo_Tag::kThirdPartyThemeInfo: {

      if (!mojo::internal::ValidatePointerNonNullable(
              object->data.f_third_party_theme_info, 3, validation_context)) {
        return false;
      }
      if (!mojo::internal::ValidateStruct(object->data.f_third_party_theme_info, validation_context))
        return false;
      return true;
    }
    default: {

      ReportValidationError(
          validation_context,
          mojo::internal::VALIDATION_ERROR_UNKNOWN_UNION_TAG,
          "unknown tag in ThemeInfo");
      return false;
    }
  }
}


// static
bool ThemeColors_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const ThemeColors_Data* object =
      static_cast<const ThemeColors_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->frame, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->frame, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->active_tab, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->active_tab, validation_context))
    return false;

  if (!mojo::internal::ValidatePointerNonNullable(
          object->active_tab_text, 3, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->active_tab_text, validation_context))
    return false;

  return true;
}

ThemeColors_Data::ThemeColors_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool ChromeTheme_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const ChromeTheme_Data* object =
      static_cast<const ChromeTheme_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->label, 2, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& label_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->label, validation_context,
                                         &label_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->colors, 3, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->colors, validation_context))
    return false;

  return true;
}

ChromeTheme_Data::ChromeTheme_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool ThirdPartyThemeInfo_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const ThirdPartyThemeInfo_Data* object =
      static_cast<const ThirdPartyThemeInfo_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->id, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& id_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->id, validation_context,
                                         &id_validate_params)) {
    return false;
  }

  if (!mojo::internal::ValidatePointerNonNullable(
          object->name, 2, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& name_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->name, validation_context,
                                         &name_validate_params)) {
    return false;
  }

  return true;
}

ThirdPartyThemeInfo_Data::ThirdPartyThemeInfo_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool Theme_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 32, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const Theme_Data* object =
      static_cast<const Theme_Data*>(data);


  if (!::customize_themes::mojom::internal::ThemeType_Data
        ::Validate(object->type, validation_context))
    return false;

  if (!mojo::internal::ValidateInlinedUnionNonNullable(
          object->info, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateInlinedUnion(object->info, validation_context))
    return false;

  return true;
}

Theme_Data::Theme_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool CustomizeThemesHandlerFactory_CreateCustomizeThemesHandler_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 24, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const CustomizeThemesHandlerFactory_CreateCustomizeThemesHandler_Params_Data* object =
      static_cast<const CustomizeThemesHandlerFactory_CreateCustomizeThemesHandler_Params_Data*>(data);

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->client, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->client,
                                                 validation_context)) {
    return false;
  }

  if (!mojo::internal::ValidateHandleOrInterfaceNonNullable(
          object->handler, 2, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateHandleOrInterface(object->handler,
                                                 validation_context)) {
    return false;
  }

  return true;
}

CustomizeThemesHandlerFactory_CreateCustomizeThemesHandler_Params_Data::CustomizeThemesHandlerFactory_CreateCustomizeThemesHandler_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool CustomizeThemesHandler_ApplyAutogeneratedTheme_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const CustomizeThemesHandler_ApplyAutogeneratedTheme_Params_Data* object =
      static_cast<const CustomizeThemesHandler_ApplyAutogeneratedTheme_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->frame_color, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->frame_color, validation_context))
    return false;

  return true;
}

CustomizeThemesHandler_ApplyAutogeneratedTheme_Params_Data::CustomizeThemesHandler_ApplyAutogeneratedTheme_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool CustomizeThemesHandler_ApplyChromeTheme_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const CustomizeThemesHandler_ApplyChromeTheme_Params_Data* object =
      static_cast<const CustomizeThemesHandler_ApplyChromeTheme_Params_Data*>(data);

  return true;
}

CustomizeThemesHandler_ApplyChromeTheme_Params_Data::CustomizeThemesHandler_ApplyChromeTheme_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool CustomizeThemesHandler_ApplyDefaultTheme_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const CustomizeThemesHandler_ApplyDefaultTheme_Params_Data* object =
      static_cast<const CustomizeThemesHandler_ApplyDefaultTheme_Params_Data*>(data);

  return true;
}

CustomizeThemesHandler_ApplyDefaultTheme_Params_Data::CustomizeThemesHandler_ApplyDefaultTheme_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool CustomizeThemesHandler_InitializeTheme_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const CustomizeThemesHandler_InitializeTheme_Params_Data* object =
      static_cast<const CustomizeThemesHandler_InitializeTheme_Params_Data*>(data);

  return true;
}

CustomizeThemesHandler_InitializeTheme_Params_Data::CustomizeThemesHandler_InitializeTheme_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool CustomizeThemesHandler_GetChromeThemes_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const CustomizeThemesHandler_GetChromeThemes_Params_Data* object =
      static_cast<const CustomizeThemesHandler_GetChromeThemes_Params_Data*>(data);

  return true;
}

CustomizeThemesHandler_GetChromeThemes_Params_Data::CustomizeThemesHandler_GetChromeThemes_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool CustomizeThemesHandler_GetChromeThemes_ResponseParams_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const CustomizeThemesHandler_GetChromeThemes_ResponseParams_Data* object =
      static_cast<const CustomizeThemesHandler_GetChromeThemes_ResponseParams_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->chromeThemes, 1, validation_context)) {
    return false;
  }
  constexpr const mojo::internal::ContainerValidateParams& chromeThemes_validate_params =
      mojo::internal::GetArrayValidator<0, false, nullptr>();
  if (!mojo::internal::ValidateContainer(object->chromeThemes, validation_context,
                                         &chromeThemes_validate_params)) {
    return false;
  }

  return true;
}

CustomizeThemesHandler_GetChromeThemes_ResponseParams_Data::CustomizeThemesHandler_GetChromeThemes_ResponseParams_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool CustomizeThemesHandler_ConfirmThemeChanges_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const CustomizeThemesHandler_ConfirmThemeChanges_Params_Data* object =
      static_cast<const CustomizeThemesHandler_ConfirmThemeChanges_Params_Data*>(data);

  return true;
}

CustomizeThemesHandler_ConfirmThemeChanges_Params_Data::CustomizeThemesHandler_ConfirmThemeChanges_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool CustomizeThemesHandler_RevertThemeChanges_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 8, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const CustomizeThemesHandler_RevertThemeChanges_Params_Data* object =
      static_cast<const CustomizeThemesHandler_RevertThemeChanges_Params_Data*>(data);

  return true;
}

CustomizeThemesHandler_RevertThemeChanges_Params_Data::CustomizeThemesHandler_RevertThemeChanges_Params_Data()
    : header_({sizeof(*this), 0}) {}


// static
bool CustomizeThemesClient_SetTheme_Params_Data::Validate(
    const void* data,
    mojo::internal::ValidationContext* validation_context) {
  if (!data)
    return true;
  if (!ValidateUnversionedStructHeaderAndSizeAndClaimMemory(
          data, 16, validation_context)) {
    return false;
  }

  // NOTE: The memory backing |object| may be smaller than |sizeof(*object)| if
  // the message comes from an older version.
  [[maybe_unused]] const CustomizeThemesClient_SetTheme_Params_Data* object =
      static_cast<const CustomizeThemesClient_SetTheme_Params_Data*>(data);

  if (!mojo::internal::ValidatePointerNonNullable(
          object->theme, 1, validation_context)) {
    return false;
  }
  if (!mojo::internal::ValidateStruct(object->theme, validation_context))
    return false;

  return true;
}

CustomizeThemesClient_SetTheme_Params_Data::CustomizeThemesClient_SetTheme_Params_Data()
    : header_({sizeof(*this), 0}) {}

}  // namespace internal
}  // namespace mojom
}  // namespace customize_themes

namespace perfetto {

// static
void TraceFormatTraits<::customize_themes::mojom::ThemeType>::WriteIntoTrace(
   perfetto::TracedValue context, ::customize_themes::mojom::ThemeType value) {
  return std::move(context).WriteString(::customize_themes::mojom::ThemeTypeToString(value));
}

} // namespace perfetto