// ui/webui/resources/js/browser_command/browser_command.mojom-shared.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2016 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef UI_WEBUI_RESOURCES_JS_BROWSER_COMMAND_BROWSER_COMMAND_MOJOM_SHARED_H_
#define UI_WEBUI_RESOURCES_JS_BROWSER_COMMAND_BROWSER_COMMAND_MOJOM_SHARED_H_

#include <stdint.h>

#include <functional>
#include <iosfwd>
#include <type_traits>
#include <utility>
#include "mojo/public/cpp/bindings/array_data_view.h"
#include "mojo/public/cpp/bindings/enum_traits.h"
#include "mojo/public/cpp/bindings/interface_data_view.h"
#include "mojo/public/cpp/bindings/lib/bindings_internal.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/map_data_view.h"
#include "mojo/public/cpp/bindings/string_data_view.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "ui/webui/resources/js/browser_command/browser_command.mojom-shared-internal.h"
#include "mojo/public/cpp/bindings/lib/interface_serialization.h"
#include "mojo/public/cpp/system/data_pipe.h"






namespace browser_command::mojom {
class ClickInfoDataView;



}  // browser_command::mojom

namespace mojo {
namespace internal {

template <>
struct MojomTypeTraits<::browser_command::mojom::ClickInfoDataView> {
  using Data = ::browser_command::mojom::internal::ClickInfo_Data;
  using DataAsArrayElement = Pointer<Data>;
  static constexpr MojomTypeCategory category = MojomTypeCategory::kStruct;
};

}  // namespace internal
}  // namespace mojo


namespace browser_command::mojom {


enum class Command : int32_t {
  
  kUnknownCommand = 0,
  
  kOpenSafetyCheck = 1,
  
  kOpenSafeBrowsingEnhancedProtectionSettings = 2,
  
  kOpenFeedbackForm = 3,
  
  kOpenPrivacyGuide = 4,
  
  kStartTabGroupTutorial = 5,
  
  kOpenPasswordManager = 6,
  
  kNoOpCommand = 7,
  
  kOpenPerformanceSettings = 8,
  
  kOpenNTPAndStartCustomizeChromeTutorial = 9,
  
  kStartPasswordManagerTutorial = 10,
  
  kStartSavedTabGroupTutorial = 11,
  
  kOpenAISettings = 12,
  
  kOpenSafetyCheckFromWhatsNew = 13,
  kMinValue = 0,
  kMaxValue = 13,
};

 std::ostream& operator<<(std::ostream& os, Command value);
inline bool IsKnownEnumValue(Command value) {
  return internal::Command_Data::IsKnownValue(
      static_cast<int32_t>(value));
}
// Interface base classes. They are used for type safety check.
class CommandHandlerFactoryInterfaceBase {};

using CommandHandlerFactoryPtrDataView =
    mojo::InterfacePtrDataView<CommandHandlerFactoryInterfaceBase>;
using CommandHandlerFactoryRequestDataView =
    mojo::InterfaceRequestDataView<CommandHandlerFactoryInterfaceBase>;
using CommandHandlerFactoryAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<CommandHandlerFactoryInterfaceBase>;
using CommandHandlerFactoryAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<CommandHandlerFactoryInterfaceBase>;
class CommandHandlerInterfaceBase {};

using CommandHandlerPtrDataView =
    mojo::InterfacePtrDataView<CommandHandlerInterfaceBase>;
using CommandHandlerRequestDataView =
    mojo::InterfaceRequestDataView<CommandHandlerInterfaceBase>;
using CommandHandlerAssociatedPtrInfoDataView =
    mojo::AssociatedInterfacePtrInfoDataView<CommandHandlerInterfaceBase>;
using CommandHandlerAssociatedRequestDataView =
    mojo::AssociatedInterfaceRequestDataView<CommandHandlerInterfaceBase>;


class ClickInfoDataView {
 public:
  ClickInfoDataView() = default;

  ClickInfoDataView(
      internal::ClickInfo_Data* data,
      mojo::Message* message)
      : data_(data) {}

  bool is_null() const { return !data_; }
  bool middle_button() const {
    return data_->middle_button;
  }
  bool alt_key() const {
    return data_->alt_key;
  }
  bool ctrl_key() const {
    return data_->ctrl_key;
  }
  bool meta_key() const {
    return data_->meta_key;
  }
  bool shift_key() const {
    return data_->shift_key;
  }
 private:
  internal::ClickInfo_Data* data_ = nullptr;
};


}  // browser_command::mojom

namespace std {

template <>
struct hash<::browser_command::mojom::Command>
    : public mojo::internal::EnumHashImpl<::browser_command::mojom::Command> {};

}  // namespace std

namespace mojo {


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::browser_command::mojom::Command, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = EnumTraits<::browser_command::mojom::Command, UserType>;

  static void Serialize(UserType input, int32_t* output) {
    *output = static_cast<int32_t>(Traits::ToMojom(input));
  }

  static bool Deserialize(int32_t input, UserType* output) {
    return Traits::FromMojom(::mojo::internal::ToKnownEnumValueHelper(
        static_cast<::browser_command::mojom::Command>(input)), output);
  }
};

}  // namespace internal


namespace internal {

template <typename MaybeConstUserType>
struct Serializer<::browser_command::mojom::ClickInfoDataView, MaybeConstUserType> {
  using UserType = typename std::remove_const<MaybeConstUserType>::type;
  using Traits = StructTraits<::browser_command::mojom::ClickInfoDataView, UserType>;

  static void Serialize(
      MaybeConstUserType& input,
      mojo::internal::MessageFragment<::browser_command::mojom::internal::ClickInfo_Data>& fragment) {
    if (CallIsNullIfExists<Traits>(input))
      return;
    fragment.Allocate();
    fragment->middle_button = Traits::middle_button(input);
    fragment->alt_key = Traits::alt_key(input);
    fragment->ctrl_key = Traits::ctrl_key(input);
    fragment->meta_key = Traits::meta_key(input);
    fragment->shift_key = Traits::shift_key(input);
  }

  static bool Deserialize(::browser_command::mojom::internal::ClickInfo_Data* input,
                          UserType* output,
                          Message* message) {
    if (!input)
      return CallSetToNullIfExists<Traits>(output);

    ::browser_command::mojom::ClickInfoDataView data_view(input, message);
    return Traits::Read(data_view, output);
  }
};

}  // namespace internal

}  // namespace mojo


namespace browser_command::mojom {




}  // browser_command::mojom

// Declare TraceFormatTraits for enums, which should be defined in ::perfetto
// namespace.

namespace perfetto {

template <>
struct  TraceFormatTraits<::browser_command::mojom::Command> {
 static void WriteIntoTrace(perfetto::TracedValue context, ::browser_command::mojom::Command value);
};

} // namespace perfetto

#endif  // UI_WEBUI_RESOURCES_JS_BROWSER_COMMAND_BROWSER_COMMAND_MOJOM_SHARED_H_